/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_AlgorithmIdentifier(unsigned char *p, size_t len, const AlgorithmIdentifier *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* parameters */
if((data)->parameters) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->parameters, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* algorithm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_oid(p, len, &(data)->algorithm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_AlgorithmIdentifier(const unsigned char *p, size_t len, AlgorithmIdentifier *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t algorithm_datalen, algorithm_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_OID, &algorithm_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
algorithm_oldlen = len;
if (algorithm_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = algorithm_datalen;
e = der_get_oid(p, len, &(data)->algorithm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = algorithm_oldlen - algorithm_datalen;
}
(data)->parameters = calloc(1, sizeof(*(data)->parameters));
if ((data)->parameters == NULL) goto fail;
e = decode_heim_any(p, len, (data)->parameters, &l);
if(e) {
free((data)->parameters);
(data)->parameters = NULL;
} else {
p += l; len -= l; ret += l;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_AlgorithmIdentifier(data);
return e;
}

void
free_AlgorithmIdentifier(AlgorithmIdentifier *data)
{
der_free_oid(&(data)->algorithm);
if((data)->parameters) {
free_heim_any((data)->parameters);
free((data)->parameters);
(data)->parameters = NULL;
}
}

size_t
length_AlgorithmIdentifier(const AlgorithmIdentifier *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_oid(&(data)->algorithm);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->parameters){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->parameters);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_AlgorithmIdentifier(const AlgorithmIdentifier *from, AlgorithmIdentifier *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_oid(&(from)->algorithm, &(to)->algorithm)) goto fail;
if((from)->parameters) {
(to)->parameters = malloc(sizeof(*(to)->parameters));
if((to)->parameters == NULL) goto fail;
if(copy_heim_any((from)->parameters, (to)->parameters)) goto fail;
}else
(to)->parameters = NULL;
return 0;
fail:
free_AlgorithmIdentifier(to);
return ENOMEM;
}

