/* Generated from ./pkinit.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkinit_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_AuthPack(unsigned char *p, size_t len, const AuthPack *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* clientDHNonce */
if((data)->clientDHNonce) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_DHNonce(p, len, (data)->clientDHNonce, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 3, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* supportedCMSTypes */
if((data)->supportedCMSTypes) {
size_t Top_tag_oldret = ret;
ret = 0;
for(i = ((data)->supportedCMSTypes)->len - 1; i >= 0; --i) {
size_t supportedCMSTypes_tag_tag_for_oldret = ret;
ret = 0;
e = encode_AlgorithmIdentifier(p, len, &((data)->supportedCMSTypes)->val[i], &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += supportedCMSTypes_tag_tag_for_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* clientPublicValue */
if((data)->clientPublicValue) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_SubjectPublicKeyInfo(p, len, (data)->clientPublicValue, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* pkAuthenticator */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_PKAuthenticator(p, len, &(data)->pkAuthenticator, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_AuthPack(const unsigned char *p, size_t len, AuthPack *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t pkAuthenticator_datalen, pkAuthenticator_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &pkAuthenticator_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
pkAuthenticator_oldlen = len;
if (pkAuthenticator_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = pkAuthenticator_datalen;
e = decode_PKAuthenticator(p, len, &(data)->pkAuthenticator, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = pkAuthenticator_oldlen - pkAuthenticator_datalen;
}
{
size_t clientPublicValue_datalen, clientPublicValue_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &clientPublicValue_datalen, &l);
if(e) {
(data)->clientPublicValue = NULL;
} else {
(data)->clientPublicValue = calloc(1, sizeof(*(data)->clientPublicValue));
if ((data)->clientPublicValue == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
clientPublicValue_oldlen = len;
if (clientPublicValue_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = clientPublicValue_datalen;
e = decode_SubjectPublicKeyInfo(p, len, (data)->clientPublicValue, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = clientPublicValue_oldlen - clientPublicValue_datalen;
}
}
{
size_t supportedCMSTypes_datalen, supportedCMSTypes_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 2, &supportedCMSTypes_datalen, &l);
if(e) {
(data)->supportedCMSTypes = NULL;
} else {
(data)->supportedCMSTypes = calloc(1, sizeof(*(data)->supportedCMSTypes));
if ((data)->supportedCMSTypes == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
supportedCMSTypes_oldlen = len;
if (supportedCMSTypes_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = supportedCMSTypes_datalen;
{
size_t supportedCMSTypes_Tag_datalen, supportedCMSTypes_Tag_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &supportedCMSTypes_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
supportedCMSTypes_Tag_oldlen = len;
if (supportedCMSTypes_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = supportedCMSTypes_Tag_datalen;
{
size_t supportedCMSTypes_Tag_Tag_origlen = len;
size_t supportedCMSTypes_Tag_Tag_oldret = ret;
size_t supportedCMSTypes_Tag_Tag_olen = 0;
void *supportedCMSTypes_Tag_Tag_tmp;
ret = 0;
((data)->supportedCMSTypes)->len = 0;
((data)->supportedCMSTypes)->val = NULL;
while(ret < supportedCMSTypes_Tag_Tag_origlen) {
size_t supportedCMSTypes_Tag_Tag_nlen = supportedCMSTypes_Tag_Tag_olen + sizeof(*(((data)->supportedCMSTypes)->val));
if (supportedCMSTypes_Tag_Tag_olen > supportedCMSTypes_Tag_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
supportedCMSTypes_Tag_Tag_olen = supportedCMSTypes_Tag_Tag_nlen;
supportedCMSTypes_Tag_Tag_tmp = realloc(((data)->supportedCMSTypes)->val, supportedCMSTypes_Tag_Tag_olen);
if (supportedCMSTypes_Tag_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->supportedCMSTypes)->val = supportedCMSTypes_Tag_Tag_tmp;
e = decode_AlgorithmIdentifier(p, len, &((data)->supportedCMSTypes)->val[((data)->supportedCMSTypes)->len], &l);
if(e) goto fail;
p += l; len -= l; ret += l;
((data)->supportedCMSTypes)->len++;
len = supportedCMSTypes_Tag_Tag_origlen - ret;
}
ret += supportedCMSTypes_Tag_Tag_oldret;
}
len = supportedCMSTypes_Tag_oldlen - supportedCMSTypes_Tag_datalen;
}
len = supportedCMSTypes_oldlen - supportedCMSTypes_datalen;
}
}
{
size_t clientDHNonce_datalen, clientDHNonce_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 3, &clientDHNonce_datalen, &l);
if(e) {
(data)->clientDHNonce = NULL;
} else {
(data)->clientDHNonce = calloc(1, sizeof(*(data)->clientDHNonce));
if ((data)->clientDHNonce == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
clientDHNonce_oldlen = len;
if (clientDHNonce_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = clientDHNonce_datalen;
e = decode_DHNonce(p, len, (data)->clientDHNonce, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = clientDHNonce_oldlen - clientDHNonce_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_AuthPack(data);
return e;
}

void
free_AuthPack(AuthPack *data)
{
free_PKAuthenticator(&(data)->pkAuthenticator);
if((data)->clientPublicValue) {
free_SubjectPublicKeyInfo((data)->clientPublicValue);
free((data)->clientPublicValue);
(data)->clientPublicValue = NULL;
}
if((data)->supportedCMSTypes) {
while(((data)->supportedCMSTypes)->len){
free_AlgorithmIdentifier(&((data)->supportedCMSTypes)->val[((data)->supportedCMSTypes)->len-1]);
((data)->supportedCMSTypes)->len--;
}
free(((data)->supportedCMSTypes)->val);
((data)->supportedCMSTypes)->val = NULL;
free((data)->supportedCMSTypes);
(data)->supportedCMSTypes = NULL;
}
if((data)->clientDHNonce) {
free_DHNonce((data)->clientDHNonce);
free((data)->clientDHNonce);
(data)->clientDHNonce = NULL;
}
}

size_t
length_AuthPack(const AuthPack *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_PKAuthenticator(&(data)->pkAuthenticator);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->clientPublicValue){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_SubjectPublicKeyInfo((data)->clientPublicValue);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->supportedCMSTypes){
size_t Top_tag_oldret = ret;
ret = 0;
{
int supportedCMSTypes_tag_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->supportedCMSTypes)->len - 1; i >= 0; --i){
int supportedCMSTypes_tag_tag_for_oldret = ret;
ret = 0;
ret += length_AlgorithmIdentifier(&((data)->supportedCMSTypes)->val[i]);
ret += supportedCMSTypes_tag_tag_for_oldret;
}
ret += supportedCMSTypes_tag_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->clientDHNonce){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_DHNonce((data)->clientDHNonce);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_AuthPack(const AuthPack *from, AuthPack *to)
{
memset(to, 0, sizeof(*to));
if(copy_PKAuthenticator(&(from)->pkAuthenticator, &(to)->pkAuthenticator)) goto fail;
if((from)->clientPublicValue) {
(to)->clientPublicValue = malloc(sizeof(*(to)->clientPublicValue));
if((to)->clientPublicValue == NULL) goto fail;
if(copy_SubjectPublicKeyInfo((from)->clientPublicValue, (to)->clientPublicValue)) goto fail;
}else
(to)->clientPublicValue = NULL;
if((from)->supportedCMSTypes) {
(to)->supportedCMSTypes = malloc(sizeof(*(to)->supportedCMSTypes));
if((to)->supportedCMSTypes == NULL) goto fail;
if((((to)->supportedCMSTypes)->val = malloc(((from)->supportedCMSTypes)->len * sizeof(*((to)->supportedCMSTypes)->val))) == NULL && ((from)->supportedCMSTypes)->len != 0)
goto fail;
for(((to)->supportedCMSTypes)->len = 0; ((to)->supportedCMSTypes)->len < ((from)->supportedCMSTypes)->len; ((to)->supportedCMSTypes)->len++){
if(copy_AlgorithmIdentifier(&((from)->supportedCMSTypes)->val[((to)->supportedCMSTypes)->len], &((to)->supportedCMSTypes)->val[((to)->supportedCMSTypes)->len])) goto fail;
}
}else
(to)->supportedCMSTypes = NULL;
if((from)->clientDHNonce) {
(to)->clientDHNonce = malloc(sizeof(*(to)->clientDHNonce));
if((to)->clientDHNonce == NULL) goto fail;
if(copy_DHNonce((from)->clientDHNonce, (to)->clientDHNonce)) goto fail;
}else
(to)->clientDHNonce = NULL;
return 0;
fail:
free_AuthPack(to);
return ENOMEM;
}

