/* Generated from ./CMS.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_CMSEncryptedData(unsigned char *p, size_t len, const CMSEncryptedData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* unprotectedAttrs */
if((data)->unprotectedAttrs) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->unprotectedAttrs, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* encryptedContentInfo */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_EncryptedContentInfo(p, len, &(data)->encryptedContentInfo, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_CMSVersion(p, len, &(data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_CMSEncryptedData(const unsigned char *p, size_t len, CMSEncryptedData *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = decode_CMSVersion(p, len, &(data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_EncryptedContentInfo(p, len, &(data)->encryptedContentInfo, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t unprotectedAttrs_datalen, unprotectedAttrs_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &unprotectedAttrs_datalen, &l);
if(e) {
(data)->unprotectedAttrs = NULL;
} else {
(data)->unprotectedAttrs = calloc(1, sizeof(*(data)->unprotectedAttrs));
if ((data)->unprotectedAttrs == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
unprotectedAttrs_oldlen = len;
if (unprotectedAttrs_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = unprotectedAttrs_datalen;
e = decode_heim_any(p, len, (data)->unprotectedAttrs, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = unprotectedAttrs_oldlen - unprotectedAttrs_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_CMSEncryptedData(data);
return e;
}

void
free_CMSEncryptedData(CMSEncryptedData *data)
{
free_CMSVersion(&(data)->version);
free_EncryptedContentInfo(&(data)->encryptedContentInfo);
if((data)->unprotectedAttrs) {
free_heim_any((data)->unprotectedAttrs);
free((data)->unprotectedAttrs);
(data)->unprotectedAttrs = NULL;
}
}

size_t
length_CMSEncryptedData(const CMSEncryptedData *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_CMSVersion(&(data)->version);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_EncryptedContentInfo(&(data)->encryptedContentInfo);
ret += Top_tag_oldret;
}
if((data)->unprotectedAttrs){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->unprotectedAttrs);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_CMSEncryptedData(const CMSEncryptedData *from, CMSEncryptedData *to)
{
memset(to, 0, sizeof(*to));
if(copy_CMSVersion(&(from)->version, &(to)->version)) goto fail;
if(copy_EncryptedContentInfo(&(from)->encryptedContentInfo, &(to)->encryptedContentInfo)) goto fail;
if((from)->unprotectedAttrs) {
(to)->unprotectedAttrs = malloc(sizeof(*(to)->unprotectedAttrs));
if((to)->unprotectedAttrs == NULL) goto fail;
if(copy_heim_any((from)->unprotectedAttrs, (to)->unprotectedAttrs)) goto fail;
}else
(to)->unprotectedAttrs = NULL;
return 0;
fail:
free_CMSEncryptedData(to);
return ENOMEM;
}

