/* Generated from ./CMS.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_ContentInfo(unsigned char *p, size_t len, const ContentInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* content */
if((data)->content) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_heim_any(p, len, (data)->content, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* contentType */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_ContentType(p, len, &(data)->contentType, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_ContentInfo(const unsigned char *p, size_t len, ContentInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = decode_ContentType(p, len, &(data)->contentType, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t content_datalen, content_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &content_datalen, &l);
if(e) {
(data)->content = NULL;
} else {
(data)->content = calloc(1, sizeof(*(data)->content));
if ((data)->content == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
content_oldlen = len;
if (content_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = content_datalen;
e = decode_heim_any(p, len, (data)->content, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = content_oldlen - content_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_ContentInfo(data);
return e;
}

void
free_ContentInfo(ContentInfo *data)
{
free_ContentType(&(data)->contentType);
if((data)->content) {
free_heim_any((data)->content);
free((data)->content);
(data)->content = NULL;
}
}

size_t
length_ContentInfo(const ContentInfo *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_ContentType(&(data)->contentType);
ret += Top_tag_oldret;
}
if((data)->content){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_heim_any((data)->content);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_ContentInfo(const ContentInfo *from, ContentInfo *to)
{
memset(to, 0, sizeof(*to));
if(copy_ContentType(&(from)->contentType, &(to)->contentType)) goto fail;
if((from)->content) {
(to)->content = malloc(sizeof(*(to)->content));
if((to)->content == NULL) goto fail;
if(copy_heim_any((from)->content, (to)->content)) goto fail;
}else
(to)->content = NULL;
return 0;
fail:
free_ContentInfo(to);
return ENOMEM;
}

