/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_DSAParams(unsigned char *p, size_t len, const DSAParams *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* g */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->g, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* q */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->q, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* p */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, &(data)->p, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_DSAParams(const unsigned char *p, size_t len, DSAParams *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t p_datalen, p_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_Integer, &p_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
p_oldlen = len;
if (p_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = p_datalen;
e = der_get_heim_integer(p, len, &(data)->p, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = p_oldlen - p_datalen;
}
{
size_t q_datalen, q_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_Integer, &q_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
q_oldlen = len;
if (q_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = q_datalen;
e = der_get_heim_integer(p, len, &(data)->q, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = q_oldlen - q_datalen;
}
{
size_t g_datalen, g_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_Integer, &g_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
g_oldlen = len;
if (g_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = g_datalen;
e = der_get_heim_integer(p, len, &(data)->g, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = g_oldlen - g_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_DSAParams(data);
return e;
}

void
free_DSAParams(DSAParams *data)
{
der_free_heim_integer(&(data)->p);
der_free_heim_integer(&(data)->q);
der_free_heim_integer(&(data)->g);
}

size_t
length_DSAParams(const DSAParams *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->p);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->q);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer(&(data)->g);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_DSAParams(const DSAParams *from, DSAParams *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_heim_integer(&(from)->p, &(to)->p)) goto fail;
if(der_copy_heim_integer(&(from)->q, &(to)->q)) goto fail;
if(der_copy_heim_integer(&(from)->g, &(to)->g)) goto fail;
return 0;
fail:
free_DSAParams(to);
return ENOMEM;
}

