/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_GeneralSubtree(unsigned char *p, size_t len, const GeneralSubtree *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* maximum */
if((data)->maximum) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, (data)->maximum, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, PRIM, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* minimum */
if((data)->minimum) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_heim_integer(p, len, (data)->minimum, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, PRIM, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* base */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_GeneralName(p, len, &(data)->base, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_GeneralSubtree(const unsigned char *p, size_t len, GeneralSubtree *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = decode_GeneralName(p, len, &(data)->base, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t minimum_datalen, minimum_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, PRIM, 0, &minimum_datalen, &l);
if(e) {
(data)->minimum = NULL;
} else {
(data)->minimum = calloc(1, sizeof(*(data)->minimum));
if ((data)->minimum == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
minimum_oldlen = len;
if (minimum_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = minimum_datalen;
e = der_get_heim_integer(p, len, (data)->minimum, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = minimum_oldlen - minimum_datalen;
}
}
{
size_t maximum_datalen, maximum_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, PRIM, 1, &maximum_datalen, &l);
if(e) {
(data)->maximum = NULL;
} else {
(data)->maximum = calloc(1, sizeof(*(data)->maximum));
if ((data)->maximum == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
maximum_oldlen = len;
if (maximum_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = maximum_datalen;
e = der_get_heim_integer(p, len, (data)->maximum, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = maximum_oldlen - maximum_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_GeneralSubtree(data);
return e;
}

void
free_GeneralSubtree(GeneralSubtree *data)
{
free_GeneralName(&(data)->base);
if((data)->minimum) {
der_free_heim_integer((data)->minimum);
free((data)->minimum);
(data)->minimum = NULL;
}
if((data)->maximum) {
der_free_heim_integer((data)->maximum);
free((data)->maximum);
(data)->maximum = NULL;
}
}

size_t
length_GeneralSubtree(const GeneralSubtree *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_GeneralName(&(data)->base);
ret += Top_tag_oldret;
}
if((data)->minimum){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer((data)->minimum);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->maximum){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_heim_integer((data)->maximum);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_GeneralSubtree(const GeneralSubtree *from, GeneralSubtree *to)
{
memset(to, 0, sizeof(*to));
if(copy_GeneralName(&(from)->base, &(to)->base)) goto fail;
if((from)->minimum) {
(to)->minimum = malloc(sizeof(*(to)->minimum));
if((to)->minimum == NULL) goto fail;
if(der_copy_heim_integer((from)->minimum, (to)->minimum)) goto fail;
}else
(to)->minimum = NULL;
if((from)->maximum) {
(to)->maximum = malloc(sizeof(*(to)->maximum));
if((to)->maximum == NULL) goto fail;
if(der_copy_heim_integer((from)->maximum, (to)->maximum)) goto fail;
}else
(to)->maximum = NULL;
return 0;
fail:
free_GeneralSubtree(to);
return ENOMEM;
}

