/* Generated from ./digest.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <digest_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_NTLMInit(unsigned char *p, size_t len, const NTLMInit *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* domain */
if((data)->domain) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_utf8string(p, len, (data)->domain, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_UTF8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* hostname */
if((data)->hostname) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_utf8string(p, len, (data)->hostname, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_UTF8String, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* flags */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_unsigned(p, len, &(data)->flags, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_NTLMInit(const unsigned char *p, size_t len, NTLMInit *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t flags_datalen, flags_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &flags_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
flags_oldlen = len;
if (flags_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = flags_datalen;
{
size_t flags_Tag_datalen, flags_Tag_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_Integer, &flags_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
flags_Tag_oldlen = len;
if (flags_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = flags_Tag_datalen;
e = der_get_unsigned(p, len, &(data)->flags, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = flags_Tag_oldlen - flags_Tag_datalen;
}
len = flags_oldlen - flags_datalen;
}
{
size_t hostname_datalen, hostname_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &hostname_datalen, &l);
if(e) {
(data)->hostname = NULL;
} else {
(data)->hostname = calloc(1, sizeof(*(data)->hostname));
if ((data)->hostname == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
hostname_oldlen = len;
if (hostname_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = hostname_datalen;
{
size_t hostname_Tag_datalen, hostname_Tag_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_UTF8String, &hostname_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
hostname_Tag_oldlen = len;
if (hostname_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = hostname_Tag_datalen;
e = der_get_utf8string(p, len, (data)->hostname, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = hostname_Tag_oldlen - hostname_Tag_datalen;
}
len = hostname_oldlen - hostname_datalen;
}
}
{
size_t domain_datalen, domain_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &domain_datalen, &l);
if(e) {
(data)->domain = NULL;
} else {
(data)->domain = calloc(1, sizeof(*(data)->domain));
if ((data)->domain == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
domain_oldlen = len;
if (domain_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = domain_datalen;
{
size_t domain_Tag_datalen, domain_Tag_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_UTF8String, &domain_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
domain_Tag_oldlen = len;
if (domain_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = domain_Tag_datalen;
e = der_get_utf8string(p, len, (data)->domain, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = domain_Tag_oldlen - domain_Tag_datalen;
}
len = domain_oldlen - domain_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_NTLMInit(data);
return e;
}

void
free_NTLMInit(NTLMInit *data)
{
if((data)->hostname) {
der_free_utf8string((data)->hostname);
free((data)->hostname);
(data)->hostname = NULL;
}
if((data)->domain) {
der_free_utf8string((data)->domain);
free((data)->domain);
(data)->domain = NULL;
}
}

size_t
length_NTLMInit(const NTLMInit *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_unsigned(&(data)->flags);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->hostname){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_utf8string((data)->hostname);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->domain){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_utf8string((data)->domain);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_NTLMInit(const NTLMInit *from, NTLMInit *to)
{
memset(to, 0, sizeof(*to));
*(&(to)->flags) = *(&(from)->flags);
if((from)->hostname) {
(to)->hostname = malloc(sizeof(*(to)->hostname));
if((to)->hostname == NULL) goto fail;
if(der_copy_utf8string((from)->hostname, (to)->hostname)) goto fail;
}else
(to)->hostname = NULL;
if((from)->domain) {
(to)->domain = malloc(sizeof(*(to)->domain));
if((to)->domain == NULL) goto fail;
if(der_copy_utf8string((from)->domain, (to)->domain)) goto fail;
}else
(to)->domain = NULL;
return 0;
fail:
free_NTLMInit(to);
return ENOMEM;
}

