/* Generated from ./pkcs12.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkcs12_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_PKCS12_PBEParams(unsigned char *p, size_t len, const PKCS12_PBEParams *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* iterations */
if((data)->iterations) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_unsigned(p, len, (data)->iterations, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_Integer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* salt */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_octet_string(p, len, &(data)->salt, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_OctetString, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_PKCS12_PBEParams(const unsigned char *p, size_t len, PKCS12_PBEParams *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t salt_datalen, salt_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_OctetString, &salt_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
salt_oldlen = len;
if (salt_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = salt_datalen;
e = der_get_octet_string(p, len, &(data)->salt, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = salt_oldlen - salt_datalen;
}
{
size_t iterations_datalen, iterations_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_Integer, &iterations_datalen, &l);
if(e) {
(data)->iterations = NULL;
} else {
(data)->iterations = calloc(1, sizeof(*(data)->iterations));
if ((data)->iterations == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
iterations_oldlen = len;
if (iterations_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = iterations_datalen;
e = der_get_unsigned(p, len, (data)->iterations, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = iterations_oldlen - iterations_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_PKCS12_PBEParams(data);
return e;
}

void
free_PKCS12_PBEParams(PKCS12_PBEParams *data)
{
der_free_octet_string(&(data)->salt);
if((data)->iterations) {
free((data)->iterations);
(data)->iterations = NULL;
}
}

size_t
length_PKCS12_PBEParams(const PKCS12_PBEParams *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_octet_string(&(data)->salt);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->iterations){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_unsigned((data)->iterations);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_PKCS12_PBEParams(const PKCS12_PBEParams *from, PKCS12_PBEParams *to)
{
memset(to, 0, sizeof(*to));
if(der_copy_octet_string(&(from)->salt, &(to)->salt)) goto fail;
if((from)->iterations) {
(to)->iterations = malloc(sizeof(*(to)->iterations));
if((to)->iterations == NULL) goto fail;
*((to)->iterations) = *((from)->iterations);
}else
(to)->iterations = NULL;
return 0;
fail:
free_PKCS12_PBEParams(to);
return ENOMEM;
}

