/* Generated from ./pkinit.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <pkinit_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_ReplyKeyPack(unsigned char *p, size_t len, const ReplyKeyPack *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* asChecksum */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Checksum(p, len, &(data)->asChecksum, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* replyKey */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_EncryptionKey(p, len, &(data)->replyKey, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_ReplyKeyPack(const unsigned char *p, size_t len, ReplyKeyPack *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t replyKey_datalen, replyKey_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &replyKey_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
replyKey_oldlen = len;
if (replyKey_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = replyKey_datalen;
e = decode_EncryptionKey(p, len, &(data)->replyKey, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = replyKey_oldlen - replyKey_datalen;
}
{
size_t asChecksum_datalen, asChecksum_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &asChecksum_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
asChecksum_oldlen = len;
if (asChecksum_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = asChecksum_datalen;
e = decode_Checksum(p, len, &(data)->asChecksum, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = asChecksum_oldlen - asChecksum_datalen;
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_ReplyKeyPack(data);
return e;
}

void
free_ReplyKeyPack(ReplyKeyPack *data)
{
free_EncryptionKey(&(data)->replyKey);
free_Checksum(&(data)->asChecksum);
}

size_t
length_ReplyKeyPack(const ReplyKeyPack *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_EncryptionKey(&(data)->replyKey);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Checksum(&(data)->asChecksum);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_ReplyKeyPack(const ReplyKeyPack *from, ReplyKeyPack *to)
{
memset(to, 0, sizeof(*to));
if(copy_EncryptionKey(&(from)->replyKey, &(to)->replyKey)) goto fail;
if(copy_Checksum(&(from)->asChecksum, &(to)->asChecksum)) goto fail;
return 0;
fail:
free_ReplyKeyPack(to);
return ENOMEM;
}

