/* Generated from ./CMS.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <cms_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_SignerInfo(unsigned char *p, size_t len, const SignerInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* unsignedAttrs */
if((data)->unsignedAttrs) {
size_t Top_tag_oldret = ret;
ret = 0;
{
struct heim_octet_string *val;
size_t elen, totallen = 0;
int eret;
if (((data)->unsignedAttrs)->len > UINT_MAX/sizeof(val[0]))
return ERANGE;
val = malloc(sizeof(val[0]) * ((data)->unsignedAttrs)->len);
if (val == NULL && ((data)->unsignedAttrs)->len != 0) return ENOMEM;
for(i = 0; i < ((data)->unsignedAttrs)->len; i++) {
ASN1_MALLOC_ENCODE(Attribute, val[i].data, val[i].length, &((data)->unsignedAttrs)->val[i], &elen, eret);
if(eret) {
i--;
while (i >= 0) {
free(val[i].data);
i--;
}
free(val);
return eret;
}
totallen += elen;
}
if (totallen > len) {
for (i = 0; i < ((data)->unsignedAttrs)->len; i++) {
free(val[i].data);
}
free(val);
return ASN1_OVERFLOW;
}
qsort(val, ((data)->unsignedAttrs)->len, sizeof(val[0]), _heim_der_set_sort);
for(i = ((data)->unsignedAttrs)->len - 1; i >= 0; --i) {
p -= val[i].length;
ret += val[i].length;
memcpy(p + 1, val[i].data, val[i].length);
free(val[i].data);
}
free(val);
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* signature */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_SignatureValue(p, len, &(data)->signature, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* signatureAlgorithm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_SignatureAlgorithmIdentifier(p, len, &(data)->signatureAlgorithm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* signedAttrs */
if((data)->signedAttrs) {
size_t Top_tag_oldret = ret;
ret = 0;
{
struct heim_octet_string *val;
size_t elen, totallen = 0;
int eret;
if (((data)->signedAttrs)->len > UINT_MAX/sizeof(val[0]))
return ERANGE;
val = malloc(sizeof(val[0]) * ((data)->signedAttrs)->len);
if (val == NULL && ((data)->signedAttrs)->len != 0) return ENOMEM;
for(i = 0; i < ((data)->signedAttrs)->len; i++) {
ASN1_MALLOC_ENCODE(Attribute, val[i].data, val[i].length, &((data)->signedAttrs)->val[i], &elen, eret);
if(eret) {
i--;
while (i >= 0) {
free(val[i].data);
i--;
}
free(val);
return eret;
}
totallen += elen;
}
if (totallen > len) {
for (i = 0; i < ((data)->signedAttrs)->len; i++) {
free(val[i].data);
}
free(val);
return ASN1_OVERFLOW;
}
qsort(val, ((data)->signedAttrs)->len, sizeof(val[0]), _heim_der_set_sort);
for(i = ((data)->signedAttrs)->len - 1; i >= 0; --i) {
p -= val[i].length;
ret += val[i].length;
memcpy(p + 1, val[i].data, val[i].length);
free(val[i].data);
}
free(val);
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* digestAlgorithm */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_DigestAlgorithmIdentifier(p, len, &(data)->digestAlgorithm, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* sid */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_SignerIdentifier(p, len, &(data)->sid, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_CMSVersion(p, len, &(data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_SignerInfo(const unsigned char *p, size_t len, SignerInfo *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = decode_CMSVersion(p, len, &(data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_SignerIdentifier(p, len, &(data)->sid, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_DigestAlgorithmIdentifier(p, len, &(data)->digestAlgorithm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t signedAttrs_datalen, signedAttrs_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &signedAttrs_datalen, &l);
if(e) {
(data)->signedAttrs = NULL;
} else {
(data)->signedAttrs = calloc(1, sizeof(*(data)->signedAttrs));
if ((data)->signedAttrs == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
signedAttrs_oldlen = len;
if (signedAttrs_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = signedAttrs_datalen;
{
size_t signedAttrs_Tag_origlen = len;
size_t signedAttrs_Tag_oldret = ret;
size_t signedAttrs_Tag_olen = 0;
void *signedAttrs_Tag_tmp;
ret = 0;
((data)->signedAttrs)->len = 0;
((data)->signedAttrs)->val = NULL;
while(ret < signedAttrs_Tag_origlen) {
size_t signedAttrs_Tag_nlen = signedAttrs_Tag_olen + sizeof(*(((data)->signedAttrs)->val));
if (signedAttrs_Tag_olen > signedAttrs_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
signedAttrs_Tag_olen = signedAttrs_Tag_nlen;
signedAttrs_Tag_tmp = realloc(((data)->signedAttrs)->val, signedAttrs_Tag_olen);
if (signedAttrs_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->signedAttrs)->val = signedAttrs_Tag_tmp;
e = decode_Attribute(p, len, &((data)->signedAttrs)->val[((data)->signedAttrs)->len], &l);
if(e) goto fail;
p += l; len -= l; ret += l;
((data)->signedAttrs)->len++;
len = signedAttrs_Tag_origlen - ret;
}
ret += signedAttrs_Tag_oldret;
}
len = signedAttrs_oldlen - signedAttrs_datalen;
}
}
e = decode_SignatureAlgorithmIdentifier(p, len, &(data)->signatureAlgorithm, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_SignatureValue(p, len, &(data)->signature, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t unsignedAttrs_datalen, unsignedAttrs_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &unsignedAttrs_datalen, &l);
if(e) {
(data)->unsignedAttrs = NULL;
} else {
(data)->unsignedAttrs = calloc(1, sizeof(*(data)->unsignedAttrs));
if ((data)->unsignedAttrs == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
unsignedAttrs_oldlen = len;
if (unsignedAttrs_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = unsignedAttrs_datalen;
{
size_t unsignedAttrs_Tag_origlen = len;
size_t unsignedAttrs_Tag_oldret = ret;
size_t unsignedAttrs_Tag_olen = 0;
void *unsignedAttrs_Tag_tmp;
ret = 0;
((data)->unsignedAttrs)->len = 0;
((data)->unsignedAttrs)->val = NULL;
while(ret < unsignedAttrs_Tag_origlen) {
size_t unsignedAttrs_Tag_nlen = unsignedAttrs_Tag_olen + sizeof(*(((data)->unsignedAttrs)->val));
if (unsignedAttrs_Tag_olen > unsignedAttrs_Tag_nlen) { e = ASN1_OVERFLOW; goto fail; }
unsignedAttrs_Tag_olen = unsignedAttrs_Tag_nlen;
unsignedAttrs_Tag_tmp = realloc(((data)->unsignedAttrs)->val, unsignedAttrs_Tag_olen);
if (unsignedAttrs_Tag_tmp == NULL) { e = ENOMEM; goto fail; }
((data)->unsignedAttrs)->val = unsignedAttrs_Tag_tmp;
e = decode_Attribute(p, len, &((data)->unsignedAttrs)->val[((data)->unsignedAttrs)->len], &l);
if(e) goto fail;
p += l; len -= l; ret += l;
((data)->unsignedAttrs)->len++;
len = unsignedAttrs_Tag_origlen - ret;
}
ret += unsignedAttrs_Tag_oldret;
}
len = unsignedAttrs_oldlen - unsignedAttrs_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_SignerInfo(data);
return e;
}

void
free_SignerInfo(SignerInfo *data)
{
free_CMSVersion(&(data)->version);
free_SignerIdentifier(&(data)->sid);
free_DigestAlgorithmIdentifier(&(data)->digestAlgorithm);
if((data)->signedAttrs) {
while(((data)->signedAttrs)->len){
free_Attribute(&((data)->signedAttrs)->val[((data)->signedAttrs)->len-1]);
((data)->signedAttrs)->len--;
}
free(((data)->signedAttrs)->val);
((data)->signedAttrs)->val = NULL;
free((data)->signedAttrs);
(data)->signedAttrs = NULL;
}
free_SignatureAlgorithmIdentifier(&(data)->signatureAlgorithm);
free_SignatureValue(&(data)->signature);
if((data)->unsignedAttrs) {
while(((data)->unsignedAttrs)->len){
free_Attribute(&((data)->unsignedAttrs)->val[((data)->unsignedAttrs)->len-1]);
((data)->unsignedAttrs)->len--;
}
free(((data)->unsignedAttrs)->val);
((data)->unsignedAttrs)->val = NULL;
free((data)->unsignedAttrs);
(data)->unsignedAttrs = NULL;
}
}

size_t
length_SignerInfo(const SignerInfo *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_CMSVersion(&(data)->version);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_SignerIdentifier(&(data)->sid);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_DigestAlgorithmIdentifier(&(data)->digestAlgorithm);
ret += Top_tag_oldret;
}
if((data)->signedAttrs){
size_t Top_tag_oldret = ret;
ret = 0;
{
int signedAttrs_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->signedAttrs)->len - 1; i >= 0; --i){
int signedAttrs_tag_for_oldret = ret;
ret = 0;
ret += length_Attribute(&((data)->signedAttrs)->val[i]);
ret += signedAttrs_tag_for_oldret;
}
ret += signedAttrs_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_SignatureAlgorithmIdentifier(&(data)->signatureAlgorithm);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_SignatureValue(&(data)->signature);
ret += Top_tag_oldret;
}
if((data)->unsignedAttrs){
size_t Top_tag_oldret = ret;
ret = 0;
{
int unsignedAttrs_tag_oldret = ret;
int i;
ret = 0;
for(i = ((data)->unsignedAttrs)->len - 1; i >= 0; --i){
int unsignedAttrs_tag_for_oldret = ret;
ret = 0;
ret += length_Attribute(&((data)->unsignedAttrs)->val[i]);
ret += unsignedAttrs_tag_for_oldret;
}
ret += unsignedAttrs_tag_oldret;
}
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_SignerInfo(const SignerInfo *from, SignerInfo *to)
{
memset(to, 0, sizeof(*to));
if(copy_CMSVersion(&(from)->version, &(to)->version)) goto fail;
if(copy_SignerIdentifier(&(from)->sid, &(to)->sid)) goto fail;
if(copy_DigestAlgorithmIdentifier(&(from)->digestAlgorithm, &(to)->digestAlgorithm)) goto fail;
if((from)->signedAttrs) {
(to)->signedAttrs = malloc(sizeof(*(to)->signedAttrs));
if((to)->signedAttrs == NULL) goto fail;
if((((to)->signedAttrs)->val = malloc(((from)->signedAttrs)->len * sizeof(*((to)->signedAttrs)->val))) == NULL && ((from)->signedAttrs)->len != 0)
goto fail;
for(((to)->signedAttrs)->len = 0; ((to)->signedAttrs)->len < ((from)->signedAttrs)->len; ((to)->signedAttrs)->len++){
if(copy_Attribute(&((from)->signedAttrs)->val[((to)->signedAttrs)->len], &((to)->signedAttrs)->val[((to)->signedAttrs)->len])) goto fail;
}
}else
(to)->signedAttrs = NULL;
if(copy_SignatureAlgorithmIdentifier(&(from)->signatureAlgorithm, &(to)->signatureAlgorithm)) goto fail;
if(copy_SignatureValue(&(from)->signature, &(to)->signature)) goto fail;
if((from)->unsignedAttrs) {
(to)->unsignedAttrs = malloc(sizeof(*(to)->unsignedAttrs));
if((to)->unsignedAttrs == NULL) goto fail;
if((((to)->unsignedAttrs)->val = malloc(((from)->unsignedAttrs)->len * sizeof(*((to)->unsignedAttrs)->val))) == NULL && ((from)->unsignedAttrs)->len != 0)
goto fail;
for(((to)->unsignedAttrs)->len = 0; ((to)->unsignedAttrs)->len < ((from)->unsignedAttrs)->len; ((to)->unsignedAttrs)->len++){
if(copy_Attribute(&((from)->unsignedAttrs)->val[((to)->unsignedAttrs)->len], &((to)->unsignedAttrs)->val[((to)->unsignedAttrs)->len])) goto fail;
}
}else
(to)->unsignedAttrs = NULL;
return 0;
fail:
free_SignerInfo(to);
return ENOMEM;
}

