/* Generated from ./rfc2459.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <rfc2459_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_TBSCertificate(unsigned char *p, size_t len, const TBSCertificate *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* extensions */
if((data)->extensions) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Extensions(p, len, (data)->extensions, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 3, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* subjectUniqueID */
if((data)->subjectUniqueID) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_bit_string(p, len, (data)->subjectUniqueID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, PRIM, 2, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* issuerUniqueID */
if((data)->issuerUniqueID) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_bit_string(p, len, (data)->issuerUniqueID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, PRIM, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* subjectPublicKeyInfo */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_SubjectPublicKeyInfo(p, len, &(data)->subjectPublicKeyInfo, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* subject */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Name(p, len, &(data)->subject, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* validity */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Validity(p, len, &(data)->validity, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* issuer */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Name(p, len, &(data)->issuer, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* signature */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_AlgorithmIdentifier(p, len, &(data)->signature, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* serialNumber */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_CertificateSerialNumber(p, len, &(data)->serialNumber, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* version */
if((data)->version) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Version(p, len, (data)->version, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_TBSCertificate(const unsigned char *p, size_t len, TBSCertificate *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;
const unsigned char *begin = p;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
{
size_t version_datalen, version_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &version_datalen, &l);
if(e) {
(data)->version = NULL;
} else {
(data)->version = calloc(1, sizeof(*(data)->version));
if ((data)->version == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
version_oldlen = len;
if (version_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = version_datalen;
e = decode_Version(p, len, (data)->version, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = version_oldlen - version_datalen;
}
}
e = decode_CertificateSerialNumber(p, len, &(data)->serialNumber, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_AlgorithmIdentifier(p, len, &(data)->signature, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_Name(p, len, &(data)->issuer, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_Validity(p, len, &(data)->validity, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_Name(p, len, &(data)->subject, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_SubjectPublicKeyInfo(p, len, &(data)->subjectPublicKeyInfo, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t issuerUniqueID_datalen, issuerUniqueID_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, PRIM, 1, &issuerUniqueID_datalen, &l);
if(e) {
(data)->issuerUniqueID = NULL;
} else {
(data)->issuerUniqueID = calloc(1, sizeof(*(data)->issuerUniqueID));
if ((data)->issuerUniqueID == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
issuerUniqueID_oldlen = len;
if (issuerUniqueID_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = issuerUniqueID_datalen;
e = der_get_bit_string(p, len, (data)->issuerUniqueID, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = issuerUniqueID_oldlen - issuerUniqueID_datalen;
}
}
{
size_t subjectUniqueID_datalen, subjectUniqueID_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, PRIM, 2, &subjectUniqueID_datalen, &l);
if(e) {
(data)->subjectUniqueID = NULL;
} else {
(data)->subjectUniqueID = calloc(1, sizeof(*(data)->subjectUniqueID));
if ((data)->subjectUniqueID == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
subjectUniqueID_oldlen = len;
if (subjectUniqueID_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = subjectUniqueID_datalen;
e = der_get_bit_string(p, len, (data)->subjectUniqueID, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = subjectUniqueID_oldlen - subjectUniqueID_datalen;
}
}
{
size_t extensions_datalen, extensions_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 3, &extensions_datalen, &l);
if(e) {
(data)->extensions = NULL;
} else {
(data)->extensions = calloc(1, sizeof(*(data)->extensions));
if ((data)->extensions == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
extensions_oldlen = len;
if (extensions_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = extensions_datalen;
e = decode_Extensions(p, len, (data)->extensions, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = extensions_oldlen - extensions_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
data->_save.data = calloc(1, ret);
if (data->_save.data == NULL) { 
e = ENOMEM; goto fail; 
}
data->_save.length = ret;
memcpy(data->_save.data, begin, ret);
if(size) *size = ret;
return 0;
fail:
free_TBSCertificate(data);
return e;
}

void
free_TBSCertificate(TBSCertificate *data)
{
der_free_octet_string(&data->_save);
if((data)->version) {
free_Version((data)->version);
free((data)->version);
(data)->version = NULL;
}
free_CertificateSerialNumber(&(data)->serialNumber);
free_AlgorithmIdentifier(&(data)->signature);
free_Name(&(data)->issuer);
free_Validity(&(data)->validity);
free_Name(&(data)->subject);
free_SubjectPublicKeyInfo(&(data)->subjectPublicKeyInfo);
if((data)->issuerUniqueID) {
der_free_bit_string((data)->issuerUniqueID);
free((data)->issuerUniqueID);
(data)->issuerUniqueID = NULL;
}
if((data)->subjectUniqueID) {
der_free_bit_string((data)->subjectUniqueID);
free((data)->subjectUniqueID);
(data)->subjectUniqueID = NULL;
}
if((data)->extensions) {
free_Extensions((data)->extensions);
free((data)->extensions);
(data)->extensions = NULL;
}
}

size_t
length_TBSCertificate(const TBSCertificate *data)
{
size_t ret = 0;
if((data)->version){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Version((data)->version);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_CertificateSerialNumber(&(data)->serialNumber);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_AlgorithmIdentifier(&(data)->signature);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Name(&(data)->issuer);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Validity(&(data)->validity);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Name(&(data)->subject);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_SubjectPublicKeyInfo(&(data)->subjectPublicKeyInfo);
ret += Top_tag_oldret;
}
if((data)->issuerUniqueID){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_bit_string((data)->issuerUniqueID);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->subjectUniqueID){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_bit_string((data)->subjectUniqueID);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->extensions){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Extensions((data)->extensions);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_TBSCertificate(const TBSCertificate *from, TBSCertificate *to)
{
memset(to, 0, sizeof(*to));
{ int ret;
ret = der_copy_octet_string(&(from)->_save, &(to)->_save);
if (ret) goto fail;
}
if((from)->version) {
(to)->version = malloc(sizeof(*(to)->version));
if((to)->version == NULL) goto fail;
if(copy_Version((from)->version, (to)->version)) goto fail;
}else
(to)->version = NULL;
if(copy_CertificateSerialNumber(&(from)->serialNumber, &(to)->serialNumber)) goto fail;
if(copy_AlgorithmIdentifier(&(from)->signature, &(to)->signature)) goto fail;
if(copy_Name(&(from)->issuer, &(to)->issuer)) goto fail;
if(copy_Validity(&(from)->validity, &(to)->validity)) goto fail;
if(copy_Name(&(from)->subject, &(to)->subject)) goto fail;
if(copy_SubjectPublicKeyInfo(&(from)->subjectPublicKeyInfo, &(to)->subjectPublicKeyInfo)) goto fail;
if((from)->issuerUniqueID) {
(to)->issuerUniqueID = malloc(sizeof(*(to)->issuerUniqueID));
if((to)->issuerUniqueID == NULL) goto fail;
if(der_copy_bit_string((from)->issuerUniqueID, (to)->issuerUniqueID)) goto fail;
}else
(to)->issuerUniqueID = NULL;
if((from)->subjectUniqueID) {
(to)->subjectUniqueID = malloc(sizeof(*(to)->subjectUniqueID));
if((to)->subjectUniqueID == NULL) goto fail;
if(der_copy_bit_string((from)->subjectUniqueID, (to)->subjectUniqueID)) goto fail;
}else
(to)->subjectUniqueID = NULL;
if((from)->extensions) {
(to)->extensions = malloc(sizeof(*(to)->extensions));
if((to)->extensions == NULL) goto fail;
if(copy_Extensions((from)->extensions, (to)->extensions)) goto fail;
}else
(to)->extensions = NULL;
return 0;
fail:
free_TBSCertificate(to);
return ENOMEM;
}

