/* Generated from ./ocsp.asn1 */
/* Do not edit */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <krb5-types.h>
#include <ocsp_asn1.h>
#include <asn1_err.h>
#include <der.h>
#include <parse_units.h>

int
encode_OCSPSingleResponse(unsigned char *p, size_t len, const OCSPSingleResponse *data, size_t *size)
{
size_t ret = 0;
size_t l;
int i, e;

i = 0;
/* singleExtensions */
if((data)->singleExtensions) {
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_Extensions(p, len, (data)->singleExtensions, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 1, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* nextUpdate */
if((data)->nextUpdate) {
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_generalized_time(p, len, (data)->nextUpdate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_GeneralizedTime, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_CONTEXT, CONS, 0, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* thisUpdate */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = der_put_generalized_time(p, len, &(data)->thisUpdate, &l);
if (e) return e;
p -= l; len -= l; ret += l;

e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, PRIM, UT_GeneralizedTime, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* certStatus */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_OCSPCertStatus(p, len, &(data)->certStatus, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
/* certID */
{
size_t Top_tag_oldret = ret;
ret = 0;
e = encode_OCSPCertID(p, len, &(data)->certID, &l);
if (e) return e;
p -= l; len -= l; ret += l;

ret += Top_tag_oldret;
}
e = der_put_length_and_tag (p, len, ret, ASN1_C_UNIV, CONS, UT_Sequence, &l);
if (e) return e;
p -= l; len -= l; ret += l;

*size = ret;
return 0;
}

int
decode_OCSPSingleResponse(const unsigned char *p, size_t len, OCSPSingleResponse *data, size_t *size)
{
size_t ret = 0;
size_t l;
int e;

memset(data, 0, sizeof(*data));
{
size_t Top_datalen, Top_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, CONS, UT_Sequence, &Top_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
Top_oldlen = len;
if (Top_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = Top_datalen;
e = decode_OCSPCertID(p, len, &(data)->certID, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
e = decode_OCSPCertStatus(p, len, &(data)->certStatus, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
{
size_t thisUpdate_datalen, thisUpdate_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_GeneralizedTime, &thisUpdate_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
thisUpdate_oldlen = len;
if (thisUpdate_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = thisUpdate_datalen;
e = der_get_generalized_time(p, len, &(data)->thisUpdate, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = thisUpdate_oldlen - thisUpdate_datalen;
}
{
size_t nextUpdate_datalen, nextUpdate_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 0, &nextUpdate_datalen, &l);
if(e) {
(data)->nextUpdate = NULL;
} else {
(data)->nextUpdate = calloc(1, sizeof(*(data)->nextUpdate));
if ((data)->nextUpdate == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
nextUpdate_oldlen = len;
if (nextUpdate_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = nextUpdate_datalen;
{
size_t nextUpdate_Tag_datalen, nextUpdate_Tag_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_UNIV, PRIM, UT_GeneralizedTime, &nextUpdate_Tag_datalen, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
nextUpdate_Tag_oldlen = len;
if (nextUpdate_Tag_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = nextUpdate_Tag_datalen;
e = der_get_generalized_time(p, len, (data)->nextUpdate, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = nextUpdate_Tag_oldlen - nextUpdate_Tag_datalen;
}
len = nextUpdate_oldlen - nextUpdate_datalen;
}
}
{
size_t singleExtensions_datalen, singleExtensions_oldlen;
e = der_match_tag_and_length(p, len, ASN1_C_CONTEXT, CONS, 1, &singleExtensions_datalen, &l);
if(e) {
(data)->singleExtensions = NULL;
} else {
(data)->singleExtensions = calloc(1, sizeof(*(data)->singleExtensions));
if ((data)->singleExtensions == NULL) { e = ENOMEM; goto fail; }
p += l; len -= l; ret += l;
singleExtensions_oldlen = len;
if (singleExtensions_datalen > len) { e = ASN1_OVERRUN; goto fail; }
len = singleExtensions_datalen;
e = decode_Extensions(p, len, (data)->singleExtensions, &l);
if(e) goto fail;
p += l; len -= l; ret += l;
len = singleExtensions_oldlen - singleExtensions_datalen;
}
}
len = Top_oldlen - Top_datalen;
}
if(size) *size = ret;
return 0;
fail:
free_OCSPSingleResponse(data);
return e;
}

void
free_OCSPSingleResponse(OCSPSingleResponse *data)
{
free_OCSPCertID(&(data)->certID);
free_OCSPCertStatus(&(data)->certStatus);
if((data)->nextUpdate) {
free((data)->nextUpdate);
(data)->nextUpdate = NULL;
}
if((data)->singleExtensions) {
free_Extensions((data)->singleExtensions);
free((data)->singleExtensions);
(data)->singleExtensions = NULL;
}
}

size_t
length_OCSPSingleResponse(const OCSPSingleResponse *data)
{
size_t ret = 0;
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_OCSPCertID(&(data)->certID);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_OCSPCertStatus(&(data)->certStatus);
ret += Top_tag_oldret;
}
{
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_generalized_time(&(data)->thisUpdate);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->nextUpdate){
size_t Top_tag_oldret = ret;
ret = 0;
ret += der_length_generalized_time((data)->nextUpdate);
ret += 1 + der_length_len (ret);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
if((data)->singleExtensions){
size_t Top_tag_oldret = ret;
ret = 0;
ret += length_Extensions((data)->singleExtensions);
ret += 1 + der_length_len (ret);
ret += Top_tag_oldret;
}
ret += 1 + der_length_len (ret);
return ret;
}

int
copy_OCSPSingleResponse(const OCSPSingleResponse *from, OCSPSingleResponse *to)
{
memset(to, 0, sizeof(*to));
if(copy_OCSPCertID(&(from)->certID, &(to)->certID)) goto fail;
if(copy_OCSPCertStatus(&(from)->certStatus, &(to)->certStatus)) goto fail;
*(&(to)->thisUpdate) = *(&(from)->thisUpdate);
if((from)->nextUpdate) {
(to)->nextUpdate = malloc(sizeof(*(to)->nextUpdate));
if((to)->nextUpdate == NULL) goto fail;
*((to)->nextUpdate) = *((from)->nextUpdate);
}else
(to)->nextUpdate = NULL;
if((from)->singleExtensions) {
(to)->singleExtensions = malloc(sizeof(*(to)->singleExtensions));
if((to)->singleExtensions == NULL) goto fail;
if(copy_Extensions((from)->singleExtensions, (to)->singleExtensions)) goto fail;
}else
(to)->singleExtensions = NULL;
return 0;
fail:
free_OCSPSingleResponse(to);
return ENOMEM;
}

